declare filename "OvertoneSinging.dsp"; declare name "OvertoneSinging"; import("stdfaust.lib");
declare options "[midi:on]";

//Chant
g = hslider("3. Gain_voix", 3, 0, 5, 0.01);
audio_input = _*0.5 : ef.transpose(2048, 2048, -12);


//Diapason qui donne un do 
t = checkbox("1. Do (diapason)"):si.smoo;
do = os.osc(130.81)*t*0.3;

//Les harmoniques 
t_harm = checkbox("4. Harmoniques"):si.smoo;
env_harm = en.ar(1, 1000*t_harm, t_harm);
g_harm  = 10*env_harm;

//Chant sur ouu
ouu = vgroup("ouu", harm_5te+harm_8ve2+harm_8ve3);

//Chant sur ooo
ooo = vgroup("ooo", harm_5te+harm_8ve2+harm_2nde);

//Chant sur aaa
aaa = vgroup("aaa", harm_5te+harm_8ve2+harm_3rce+harm_3rce2+harm_trit);

//Chant sur iii
iii = vgroup("iii", harm_5te+harm_8ve3+harm_trit);

//Chant sur eeu
eeu = vgroup("eeu", harm_5te+harm_8ve2+harm_3rce+harm_5te2+harm_2nde);

//2ème harmonique 
q_5te = hslider("4.2. q5te", 1, 1, 600, 1) : si.smoo;
harm_5te = audio_input*0.1 <: fi.resonlp(783.99, q_5te, g_harm);

//3ème harmonique 
q_8ve2 = hslider("4.3. q8ve2", 1, 1, 600, 1) : si.smoo;
harm_8ve2 = audio_input*0.1 <: fi.resonlp(1046.5, q_8ve2, g_harm);

//4ème harmonique 
q_3rce = hslider("4.4. q3rce", 1, 1, 600, 1) : si.smoo;
harm_3rce = audio_input*0.1 <: fi.resonlp(1318.51, q_3rce, g_harm);

//5ème harmonique 
q_5te2 = hslider("4.5. q5te2", 1, 1, 600, 1) : si.smoo;
harm_5te2 = audio_input*0.1 <: fi.resonlp(1567.98, q_5te2, g_harm);

//7ème harmonique 
q_8ve3 = hslider("4.6. q8ve3", 1, 1, 600, 1) : si.smoo;
harm_8ve3 = audio_input*0.1 <: fi.resonlp(2093, q_8ve3, g_harm);

//8ème harmonique
q_2nde = hslider("4.7. q2nde", 1, 1, 1000, 1) : si.smoo;
harm_2nde = audio_input*0.1 <: fi.resonlp(2349.32, q_2nde, g_harm);

//9ème harmonique
q_3rce2 = hslider("4.8. q3rce2", 1, 1, 600, 1) : si.smoo;
harm_3rce2 = audio_input*0.1 <: fi.resonlp(2637.02, q_3rce2, g_harm);

//10ème harmonique
q_trit = hslider("4.9. qtrit", 1, 1, 1000, 1) : si.smoo;
harm_trit = audio_input*0.1 <: fi.resonlp(2959.93, q_trit, g_harm);


//voyelles = hslider("4. modes[style:menu{'ouu':0;'uuu':1;'ooo':2;'aaa':3;'iii':4;'eeu':5;'ééé':6}]", 0, 0, 6, 1);
voyelles = hslider("5. voyelles[style:menu{'ouu':0;'ooo':1;'aaa':2;'iii':3;'eeu':4}]", 0, 0, 5, 1);
voyelle = ouu, ooo, aaa, iii, eeu : ba.selectn(5, voyelles);


//process = sp.stereoize((sig*g) + harm_5te+ harm_8ve2 +harm_3rce +harm_5te2+ harm_8ve3+harm_2nde+harm_3rce2+harm_trit+do);
process = sp.stereoize((audio_input*g) + voyelle + do);
//process = sp.stereoize((sig*g)+harm_8ve2);